'****************************************************************
'*  Name    : Test2_HRSout.BAS                                  *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2009 [A FREIXANET]                  *
'*          : All Rights Reserved                               *
'*  Date    : 23/02/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : Demo for the HRSOut command by interrupys         *
'*          : Powered by Proton Basic Compiler Version 3.5.7.8  *
'*          : Using the PIC18F25K20, PIC18F25K22, PIC18F26K22   *
'****************************************************************
'*
'*
'===============================================================================
'* Is is a Demo for testing the UART command by interrupt.
'* Method:
'* Writing to the UART has no waiting time because all data are writen first into an array.
'* Sending bytes To the UART is making in the background by interrupts determined by the Baud Rate.
'
'* Use the ISIS Proton Board (PIC18_ALCD_VHB.DSN) included in the Proton Basic Compiler
'* with the 18F452 code.
'* The Timer2 is used for this demo.
'* The Timer2 is better for this function because less code is written then it is much faster.
'*******************************************************************************
'===============================================================================
' This program is free software, you can redistribute it and/or modify.
' The code is offered as-is and the author take any responsibility for its use.
' This program is distributed in the hope that it will be useful, but WITHOUT ANY
' WARRANTY. However, a mention of the author and compiler would be appreciated.
'
' Este programa es un software libre, puede redistribuirlo y/o modificarlo.
' Se entrega este cdigo tal como esta y el autor NO se hace responsable de
' su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.

' Ce programme est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' Ce logiciel est offert tel qu'il est, et son auteur NE prend AUCUNE responsabilit
' pour son utilization. Ce programme est distribu dans l'espoir qu'il sera util,
' mais SANS AUCUNE GARANTIE. Cependant mentionner l'auteur et le compileur serait
' aprci.
'===============================================================================
'===============================================================================
' Header file for the Proton Development Board

' Change the Device (18F25K20, 18F25K22 or 18F26K22), compile and test with the ISIS in different folders (or the Amicus18 board).
    Device = 18F25K20
'    Device = 18F25K22
'    Device = 18F26K22

'-------------------------------------------------------------------------------
' Use the Fuse Configurator plug-in to change these settings
$if _device = _18F25k22
Config_Start
    Debug = Off       ' Background debugger disabled' RB6 and RB7 configured as general purpose I/O pins
    WDTEN = Off       ' WDT disabled (control is placed on SWDTEN bit)
    FOSC = HSMP       ' HS oscillator (low power 4 to 16 MHz)
    PLLCFG = On       ' Oscillator multiplied by 4
    XINST = Off       ' Extra Instruction Set Disabled
    FCMEN = On        ' Fail-Safe Clock Monitor enabled
    IESO = Off        ' Oscillator Switchover mode disabled
    PWRTEN = On       ' PWRT on
    BOREN = On        ' Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 190        ' VBOR set to 1.9 V nominal
    WDTPS = 128       ' 1:128
    MCLRE = EXTMCLR   ' MCLR pin enabled, RE3 input pin disabled
    HFOFST = Off      ' The system clock is held off until the HF-INTOSC is stable.
    PRICLKEN = On     ' Primary clock enabled
    PBADEN = Off      ' PORTB<4:0> pins are configured as digital I/O on Reset
    CCP2MX = PORTC1   ' CCP2 input/output is multiplexed with RC1
    CCP3MX = PORTB5   ' P3A/CCP3 input/output is multiplexed with RB5
    T3CMX = PORTC0    ' T3CKI is on RC0
    P2BMX = PORTB5    ' P2B is on RB5
    STVREN = On       ' Stack full/underflow will cause Reset
    LVP = Off         ' Single-Supply ICSP disabled
    Cp0 = Off         ' Block 0 (000800-001FFFh) not code-protected
    CP1 = Off         ' Block 1 (002000-003FFFh) not code-protected
    CPB = Off         ' Boot block (000000-0007FFh) not code-protected
    CPD = Off         ' Data EEPROM not code-protected
    WRT0 = Off        ' Block 0 (000800-001FFFh) not write-protected
    WRT1 = Off        ' Block 1 (002000-003FFFh) not write-protected
    WRTB = Off        ' Boot block (000000-0007FFh) not write-protected
    WRTC = Off        ' Configuration registers (300000-3000FFh) not write-protected
    WRTD = Off        ' Data EEPROM not write-protected
    EBTR0 = Off       ' Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = Off       ' Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTRB = Off       ' Boot block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
$endif

$if _device = _18F26k22
Config_Start
    Debug = Off       ' Background debugger disabled' RB6 and RB7 configured as general purpose I/O pins
    WDTEN = Off       ' WDT disabled (control is placed on SWDTEN bit)
    FOSC = HSMP       ' HS oscillator (low power 4 to 16 MHz)
    PLLCFG = On       ' Oscillator multiplied by 4
    XINST = Off       ' Extra Instruction Set Disabled
    FCMEN = On        ' Fail-Safe Clock Monitor enabled
    IESO = Off        ' Oscillator Switchover mode disabled
    PWRTEN = On       ' PWRT on
    BOREN = On        ' Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 190        ' VBOR set to 1.9 V nominal
    WDTPS = 128       ' 1:128
    MCLRE = EXTMCLR   ' MCLR pin enabled, RE3 input pin disabled
    HFOFST = Off      ' The system clock is held off until the HF-INTOSC is stable.
    PRICLKEN = On     ' Primary clock enabled
    PBADEN = Off      ' PORTB<4:0> pins are configured as digital I/O on Reset
    CCP2MX = PORTC1   ' CCP2 input/output is multiplexed with RC1
    CCP3MX = PORTB5   ' P3A/CCP3 input/output is multiplexed with RB5
    T3CMX = PORTC0    ' T3CKI is on RC0
    P2BMX = PORTB5    ' P2B is on RB5
    STVREN = On       ' Stack full/underflow will cause Reset
    LVP = Off         ' Single-Supply ICSP disabled
    Cp0 = OFF	      'Block 0 (000800-003FFFh) not code-protected
    CP1 = OFF	      'Block 1 (004000-007FFFh) not code-protected
    CP2 = OFF	      'Block 2 (008000-00BFFFh) not code-protected
    CP3 = OFF	      'Block 3 (00C000-00FFFFh) not code-protected
    CPB = OFF	      'Boot block (000000-0007FFh) not code-protected
    CPD = OFF	      'Data EEPROM not code-protected
    WRT0 = OFF	      'Block 0 (000800-003FFFh) not write-protected
    WRT1 = OFF	      'Block 1 (004000-007FFFh) not write-protected
    WRT2 = OFF	      'Block 2 (008000-00BFFFh) not write-protected
    WRT3 = OFF	      'Block 3 (00C000-00FFFFh) not write-protected
    WRTC = OFF	      'Configuration registers (300000-3000FFh) not write-protected
    WRTB = OFF	      'Boot Block (000000-0007FFh) not write-protected
    WRTD = OFF	      'Data EEPROM not write-protected
    EBTR0 = OFF	      'Block 0 (000800-003FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	      'Block 1 (004000-007FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	      'Block 2 (008000-00BFFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	      'Block 3 (00C000-00FFFFh) not protected from table reads executed in other blocks
    EBTRB = OFF	      'Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
$endif

$if _device = _18F25k20
Config_Start
 Debug = OFF      ' Background debugger disabled' RB6 and RB7 configured as general purpose I/O pins
 XINST = OFF      ' Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
 STVREN = OFF     ' Reset on stack overflow/underflow disabled
 WDTEN = OFF      ' WDT disabled (control is placed on SWDTEN bit)
 FCMEN = OFF      ' Fail-Safe Clock Monitor disabled
 FOSC = HSPLL     ' HS oscillator, PLL enabled and under software control
 IESO = OFF       ' Two-Speed Start-up disabled
 WDTPS = 128      ' 1:128
 BOREN = OFF      ' Brown-out Reset disabled in hardware and software
 BORV = 18        ' VBOR set to 1.8 V nominal
 MCLRE = On       ' MCLR pin enabled, RE3 input pin disabled
 HFOFST = OFF     ' The system clock is held off until the HF-INTOSC is stable.
 LPT1OSC = OFF    ' T1 operates in standard power mode
 PBADEN = OFF     ' PORTB<4:0> pins are configured as digital I/O on Reset
 CCP2MX = PORTC   ' CCP2 input/output is multiplexed with RC1
 LVP = OFF        ' Single-Supply ICSP disabled
 Cp0 = OFF        ' Block 0 (000800-001FFFh) not code-protected
 CP1 = OFF        ' Block 1 (002000-003FFFh) not code-protected
 CPB = OFF        ' Boot block (000000-0007FFh) not code-protected
 CPD = OFF        ' Data EEPROM not code-protected
 WRT0 = OFF       ' Block 0 (000800-001FFFh) not write-protected
 WRT1 = OFF       ' Block 1 (002000-003FFFh) not write-protected
 WRTB = OFF       ' Boot block (000000-0007FFh) not write-protected
 WRTC = OFF       ' Configuration registers (300000-3000FFh) not write-protected
 WRTD = OFF       ' Data EEPROM not write-protected
 EBTR0 = OFF      ' Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
 EBTR1 = OFF      ' Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
 EBTRB = OFF      ' Boot block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
$endif
'-------------------------------------------------------------------------------   
    ' Settings CPU Proteus as 16Mhz (with settings fuses)
    Declare Xtal = 64
    Declare Optimiser_Level = 2
    Declare Dead_Code_Remove = On       ' Remove redundant Asm mnemonics
'-------------------------------------------------------------------------------
' Uncomment this 'define' to run the code with the LCD.
    $define _LCD_

' Uncomment a line to define a Terminal Baud Rate, and compile. (One only)
' Modify the Baud Rate in the ISIS Terminal too.
'    $define _9600B_
'    $define _19200B_    
    $define _38400B_
'    $define _57600B_        
'-------------------------------------------------------------------------------
' If there is not a LCD connected to your Amicus18 board, disable the LCD code.
    $ifdef _LCD_
    Declare LCD_DTPin = PORTB.0
    Declare LCD_RSPin = PORTC.0
    Declare LCD_ENPin = PORTC.1
    Declare LCD_Interface = 4
    Declare LCD_Lines = 2
    Declare LCD_Type = 0
    Declare LCD_CommandUs = 2000
    Declare LCD_DataUs = 50
    $endif
    
    $ifdef _9600B_
    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
    ' For the 9600 Bauds copy and paste these lines of code.
    @#define __HSERIAL_BAUD 9600
    Declare Hserial_RCSTA  = %10010000  ' Enable continuous receive 
    Declare Hserial_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
    Declare Hserial_Clear  = On         ' Clear overflow automatically
    Declare Hserial_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
    $endif

    $ifdef _19200B_
    Declare Hserial_Baud = 19200        ' Set baud rate to 19200
    Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif

    $ifdef _38400B_
    Declare Hserial_Baud = 38400        ' Set baud rate to 38400
    Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif

    $ifdef _57600B_
    Declare Hserial_Baud = 57600        ' Set baud rate to 57600
    Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
'-------------------------------------------------------------------------------
' The user can change the SFR flags using the 18F25K20.def, 18F26K22 or 18F25K22.def files of PDS.
    $if (_device = _18F25k22) Or (_device = _18F26k22)
'    Include "D:\MyIncFiles\SYS_18F2X-4xk22.INC"
    Include "SYS_18F2X-4xk22.INC"    
    $endif

    $if (_device = _18F25k20)
'    Include "D:\MyIncFiles\SYS_18Fxxk20.INC"
    Include "SYS_18Fxxk20.INC"
    $endif        
'===============================================================================
    Symbol LED1 = LATA.0
    Symbol LED2 = LATA.1
    Symbol LED3 = LATA.2
    Symbol LED4 = LATA.3
    Symbol IntPulse = LATC.2       ' See the pulses of the interrupts in the oscilloscope.
'*******************************************************************************
' Uncomment this line to use the oscilloscope to see the interrupt pulses. (only for this demo).
    $define _DebugInterrupt_

'-------------------------------------------------------------------------------
' Declare the UART Buffer Size. Power of 2: 16, 32, 64, 128, max 256 
    $define UARTBufferSize 256

' The Interrupt handler file must be placed on the top of your main program.
'    Include "D:\MyIncFiles\HRSOutInterrupt.Inc"
    Include "HRSOutInterrupt.Inc"

' More library file...
'
'*******************************************************************************
' Variables for the demo.
'
    Dim LoopCounter As Byte
'-------------------------------------------------------------------------------
STARTING_TEST:
    #ifdef WatchDog_Req
    Clrwdt
    #endif
    $ifdef _LCD_
    Cls
    $endif
    TRISA = %00000000                       ' All pins portA output
    TRISB = %00000000                       ' All pins portB output
    DelayMS 200
'-------------------------------------------------------------------------------    
'Init variables
    'For demo 
    Low LED1
    Low LED2
    Low LED3
    Low LED4
'-------------------------------------------------------------------------------
    'Enable the interrupts
    INTCON = %11000000
    INTCON2 = %10000000     ' PORTB Pullups disabled
'
    INTCON3 = 0
    EECON1 = 0              ' Clear all eeprom flags.
    PIR2 = 0
    PIE2 = 0
    IPR2 = 0                    
'
' Declare all digital   
    ADCON0 = 0
    ADCON1 = 15
    ADCON2 = 0    
    CM1CON0 = 0
    CM2CON0 = 0
    CM2CON1 = 0    
    $ifdef _ANSEL 
    ANSEL = 0
    ANSELH = 0
    $endif
    $ifdef _ANSELA
    ANSELA = 0
    $endif
    $ifdef _ANSELB
    ANSELB = 0
    $endif
    $ifdef _ANSELC
    ANSELC = 0
    $endif
    $ifdef _ANSELD
    ANSELD = 0
    $endif    
    $ifdef _ANSELE
    ANSELE = 0
    $endif    
'
' Disable Pull-up resistors in PORTB
    F_NOT_RBPU = 1
'
' Init the eeprom
    EECON1 = 0
    EEADR = 0
    EEDATA = 0
'
' PORTS
    Output PORTB
    Output PORTA
'
'Other parameters
    LoopCounter = 0     
'------------------------------------------------------------------------------- 
MAIN_START:
    HRSOut "HRSout by interrupt by A. Freixanet", CR
    HRSOut "Send ASCII bytes to the UART by interrupt", CR   
    $if ((_device != _18F25k20) && (_device != _18F25k22) && (_device != _18F26k22))
    $error "This DEMO is for the PIC18F25K20 Or PIC18F25K22 Or PIC18F25K22 devices! Change the Config fuses."
    $endif
    HRSOut "TESTING the HRSOut command by Interrupts.", CR  

    ' See the Baud Rate on the terminal.
    #if (__HSERIAL_BAUD == 9600)
    HRSOut "Declare Hserial_Baud = 9600", CR
    #endif
    #if (__HSERIAL_BAUD == 19200)
    HRSOut "Declare Hserial_Baud = 19200", CR
    #endif
    #if (__HSERIAL_BAUD == 38400)
    HRSOut "Declare Hserial_Baud = 38400", CR
    #endif
    #if (__HSERIAL_BAUD == 57600)
    HRSOut "Declare Hserial_Baud = 57600", CR
    #endif
    HRSOut CR
'*******************************************************************************
WRITE_AGAIN:
    $ifdef _LCD_
    Cls
    $endif
    '---------------------------------------------------------------------------
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    HRSOut "HRSOut command by interrupts", CR  
    '...
    ' While this code is running, the interrupt handler is writing to the terminal.
    '...
    $ifdef _LCD_
    Print At 1,1, "HRSOut command"
    Print At 2,1, "by interrupts,"
    DelayMS 1000
    $endif
    '...
    Toggle LED1
    Toggle LED2    
    Toggle LED3
    Toggle LED4        
    '...
    HRSOut "is writing ASCII To the Terminal,", CR 
    $ifdef _LCD_
    Cls
    Print At 1,1, "is writing ASCII"
    Print At 2,1, "to the Terminal,"
    DelayMS 1000
    $endif
    '...
    Toggle LED1
    Toggle LED2    
    Toggle LED3
    Toggle LED4  
    '...        
    HRSOut "while text is printing To the LCD.", CR,CR 
    $ifdef _LCD_
    Cls
    Print At 1,1, "while text is"
    Print At 2,1, "printing to "
    DelayMS 1000
    $endif
    '...
    Toggle LED1
    Toggle LED2    
    Toggle LED3
    Toggle LED4  
    '...
    $ifdef _LCD_
    Cls    
    Print At 1,1, "the LCD. END"
    DelayMS 1000    
    $endif
    '...
    Toggle LED1
    Toggle LED2    
    Toggle LED3
    Toggle LED4  
    '...

    $ifndef _LCD_
    DelayMS 100
    $endif
    GoTo WRITE_AGAIN              
'*******************************************************************************
    Stop 
              
